# addring.cl -- add rings around all objects in a mask image
#
# Calls task "minv" if bad pixels are zero-valued, since this task needs "bad"
# pixels (the ones around which rings are added) to have values of 1 to work.
#
# 920711: created by John S. Ward
# 930519: Mod. by MD to make it compatable with .pl masks, to add mask 
# 	  as query parameter, to make number of added rings a variable.
# 950220: modified for different input, output names and bad pixel values
# 950725: fixed bug of too many minv's if outmask=inmask
# 970801: changed so that it copies to an intermediate image, thus avoiding
#	  problem of minv messing up original input files
# 980708: optimized coding a bit, cutting down on number of imcopies etc.

procedure addring(inmask,outmask)

string	inmask	{prompt="Name of input mask image"}
string	outmask	{prompt="Name of output mask image"}
int	ngrow	{1,min=0,prompt="Number of pixel rings to grow around mask"}
int     badval  {0,min=0,max=1,prompt="Value for `bad' pixels around which to grow rings"}

begin

	string	inmi		# equals inmask
	string	outmi		# equals outmask
	int	nbox
	int	nbox2 

	inmi = inmask
	outmi = outmask
	nbox = 2 * ngrow + 1
	nbox2 = nbox * nbox

	if (badval==0) {
		minv(inmi,outmi)
		imarith (outmi,"*",nbox2,outmi,ver-)
	} else {
		imarith (inmi,"*",nbox2,outmi,ver-)
	}
	boxcar (outmi,outmi,nbox,nbox)
	imreplace (outmi,1.,lower=1.,upper=INDEF)
	if(badval==0)minv(outmi,outmi)

end

