procedure dophiirs(ilist,rootname,badpixmask,instrument)

# dophiirs.cl -- batch job for phiirs reductions
#
# 990205: begin creation
# 990309: merged with dophpars.par & removed irrotate bits
# 990318: flat_tpl and sky_tpl options
# 990320: added patternsub option; modified flat_tpl and sky_tpl options
# 990324: added editimshift option
# 990420: irflat: added premask, forcescale, & comment about using objmasks 
# 990506: changed name of subdark parameter to imgdark
# 990523: objmask+: check for image list existence before doing hedit on it
#
# **possible improvements:
# **edit for SQIID
# **does irflat assume goodval=1 & require minv/imcalc?
#
# **bug: docoadd+ redo- doesn't work... new coadd made
# **bug if domkobjmask+ redo- and existing objmask (problem just w/imextn?)
#
# --ideally want it to know how to do std defaults without being told
#   (e.g. if flatfield but no skysub, sub=yes on mkobjmask, trim)
# --output batch file equivalent
# --crzap, photcheck, photscale: see dophiirs_990217noon.cl
# --not included:  mkbpm, mkdark, mkflat, irshift2, immatch.geomap, precoadd

#		COMMAND-LINE PARAMETERS
string	ilist		{prompt="List of original images"}
string	rootname	{prompt="Rootname to use for files"}
string	badpixmask	{prompt="Bad pixel mask (if none, set masktyp=none)"}
string	instrument	{"generic",enum="generic|irim|kir|nsfcam|onis|pisces|so256",prompt="Generic or specific instrument?"}
#		WHICH TASKS TO DO? PARAMETERS
bool	dofirst=no	{prompt="Add header parameters to raw images?"}
bool	redo=no		{prompt="Redo a step even if it's already been done?"}
string	imgdark=""      {prompt="Dark to subtract (dofirst+/domeflat/qkflat)"}
string  doflat="none"   {enum="none|domeflat|irflat|qkflat",prompt="Which task to use for flattening?"}
string  dosky="none"	{enum="none|irsky|qksky",prompt="Which task to use for sky-subtraction?"}
bool 	objmask=no	{prompt="Use object masks to make flat & sky?"}
bool	getstats=no	{prompt="Get statistics for images to be coadded?"}
bool	doshift=no	{prompt="Measure image shifts (poss. INTERACTIVE)?"}
bool	docoadd=no	{prompt="Do coadding?"}
bool   domkobjmask=no {prompt="Make coadded-image objmask (poss. INTERACTIVE)?"}
bool domasklet=no {prompt="Make individual-image objmasks (poss. INTERACTIVE)?"}
bool 	dotrim=no	{prompt="Create constant-rms image w/minimum exptime?"}
bool	makenoise=yes	{prompt="Beep when tasks are done?\n--GENERAL PARAMETERS----------------------------"}
#		GENERAL PARAMETERS
string  darkstring="d"	{prompt="String to append to dark-subtracted images"}
string  flatstring="f"	{prompt="String to append to flat-fielded images"}
string  skystring="s"	{prompt="String to append to sky-subtracted images"}
string	logfile=""	{prompt="Name of log file"}
string	imflatpars="" {prompt="Generic IRFLAT/QKFLAT imcombine params filename"}
string	imskypars=""	{prompt="Generic IRSKY/QKSKY imcombine params filename"}
string	imcoaddpars=""	{prompt="Generic IRCOADD imcombine params filename"}
string masktyp="badval" {prompt="Mask type (badval|goodval|none)"}
real   maskval=0.    {prompt="Mask value for mask type (goodval|badval) pixels"}
string im_extn="fits"	{prompt="Image type extension to use\n--DOFIRST+ PARAMETERS---------------------------"}
#		DOFIRST+ PARAMETERS
bool	coords=no	{prompt="Add RA, DEC, and EPOCH to image header?"}
bool	airmass=no	{prompt="Enter airmass into image header?"}
bool	airauto=no	{prompt="Find airmass of image automatically?"}
string	epoch=""	{prompt="Epoch of coordinates"}
string	ra=""		{prompt="Right Ascension (surround with quotes)"}
string	dec=""	     {prompt="Declination (surround w/quotes; use - but not +)"}
string	observatory=""	{prompt="Observatory where observations were made"}
bool	ut=yes		{prompt="Is 'time-obs' in header ut or not?"}
bool	ddmmyy=no	{prompt="Is 'date-obs' in day/month/year format?\n--FLATFIELDING & SKY-SUBTRACTION PARAMETERS-----"}
#		FLATFIELDING & SKY-SUBTRACTION PARAMETERS
bool	zeroout=no	{prompt="Zero out bad pixels (domeflat/qkflat/qksky)?"}
string	flatfield=""	{prompt="Name of flatfield image to use (domeflat)"}
real    flat_num=INDEF {prompt="Total even # of imgs for running flat (irflat)"}
bool	flatsave=no	{prompt="Save individual flatfield images?"}
string	objmsuffix="om"	{prompt="Suffix of object masks"}
bool    remake=no 	{prompt="Remake existing flat or sky (qkflat/qksky)?"}
bool	iterstat=yes	{prompt="Use iterative means for quick flats & skys?"}
bool	premask=no      {prompt="Mask bad pixels before creating flats/skys?"}
bool	apply=yes    {prompt="Apply quick flats & skys to images once created?"}
real    sky_num=INDEF  {prompt="Total even # of images for running sky (irsky)"}
bool	skysave=no         {prompt="Save individual sky images?"}
string	patternsub="never" {enum="during|after|never",prompt="Subtract pattern noise (during|after) skysub, or (never)?"}
string whentpl="never" {enum="flat|sky|never",prompt="Throughput-correct images after (flat|sky|never)"}
string	tplname=""     {prompt="FULL name of throughput correction image"}
bool	addsky=no      {prompt="Add median sky level after subtraction?"}
bool	forcescale=no  {prompt="Force recalculation of image medians?"}
bool	shortcut=yes   {prompt="Use quick way to scale sky for subtraction?\n--IRSHIFT PARAMETERS (DOSHIFT+)-----------------"}
#		IRSHIFT PARAMETERS (DOSHIFT+)
string	refimage=""    {prompt="Name of reference image for irshift"}
string	prefix=""      {prompt="irshift files prefix string (default=rootname)"}
string  suffix=""  {prompt="irshift files suffix string (default=shN; N=1,2..)"}
bool	useimages=yes  {prompt="Measure shifts from images instead of a file?"}
bool	displayim=yes  {prompt="Display images for imexam?"}
bool	ptv=no	       {prompt="Use phat.ptv instead of display in imexam?"}
string	imsection=""   {prompt="Image section to display in imexam?"}
bool	editfiles=yes  {prompt="Display coords files for editing?\n--IRCOADD PARAMETERS (DOCOADD+)-----------------"}
#		IRCOADD PARAMETERS (DOCOADD+)
string coaddimage=""	{prompt="Coadded image name (default=rootname//_coaddN, N=1,2...)"}
string expmap=""	{prompt="Exposure map image (default=coaddimage//em)"}
string scaling="none"	{prompt="Scaling for coadd (none|@file|!keyword|etc.)"}
string zeroing="mode"	{prompt="Zero offsets for coadd (none|@file|mode|etc.)"}
string weighting="none" {prompt="Weighting for coadd (none|@file|!keyword|etc.)"}
int	magfac  {1,min=1,max=10,prompt="Subpixel shifting magnification factor"}
bool	prescale=no	{prompt="Scale images before, not during, imcombine?"}
bool	prezero=no   {prompt="Do zero offseting before, not during, imcombine?"}
bool	stack=no	{prompt="Combine images by stacking & projecting?"}
bool	unstack=no	{prompt="Delete stacked image & expmap when done?"}
bool	unzero=no	{prompt="Undo zero offsets when done?"}
bool	unscale=no	{prompt="Undo scaling factors when done?"}
bool	putscale=no	{prompt="Insert scaling factors into image headers?"}
string	wordscale="SCALEFAC"	{prompt="Scaling factor header keyword"}
bool	putzero=no	{prompt="Insert zero offsets into image headers?"}
string	wordzero="ZEROVAL"	{prompt="Zero offset header keyword"}
bool	putweight=no	{prompt="Insert weights into image headers?"}
string	wordweight="WEIGHT"	{prompt="Weighting factor header keyword"}
real	extcoeff=0.05	{prompt="Extinction coefficient for default scalings"}
real	airzero=1.	{prompt="Airmass to scale to? (INDEF=min. observed)"}
bool	maskedstat=no	{prompt="Use maskstat to find default zeros & weights?"}
string	statfile=""	{prompt="File for image statistics"}
bool	makeavg=no	{prompt="Make pure coadd (comb=average,rej=none)?"}
bool	flip=no	{prompt="Flip image L-R after coadd?\n--MKOBJMASK/MASKLET PARAMETERS (DOMKOBJMASK+/DOMASKLET+)--"}
#		MKOBJMASK/MASKLET PARAMETERS (DOMKOBJMASK+/DOMASKLET+)
string	areamask=""	{prompt="Exposed area mask (default: image//mask.pl)"}
bool	subtract=no	{prompt="Subtract average beforehand (ALSO DOTRIM+)?"}
string	substring="sub" {prompt="Suffix string for subtracted image, if made"}
int    nsmooth {3,min=0,prompt="Boxcar smoothing filter size (ODD values only)"}
int 	subsample {1,min=1,prompt="Subsampling factor before median filtering"}
int 	filtsize {15,min=1,prompt="Filter size for local median sky evaluation"}
int	ngrow	{1,min=0,prompt="Width of rings to grow around masked objects"}
bool	interact=yes	{prompt="Interactively examine normalized image?"}
bool	editimshift=yes	{prompt="Edit Image+Shifts file in masklet?\n--TRIM PARAMETERS (DOTRIM+; ALSO subtract)------"}
#		TRIM PARAMETERS (DOTRIM+; ALSO subtract UNDER MKOBJMASK ABOVE)
string stats=""	     {prompt="File to contain trimmed image RMS values"}
real mingoodexp=0.36 {prompt="Minimum acceptable exptime (fraction of maximum)"}

begin

string i_list, root_name, log_file, instru_ment, BP_mask, stat_list, do_flat
string x_tmpstring, y_tmpstring, d_statfile, x_oldstring, d_rotsuffix, do_sky
string d_dark, d_darkstring, d_flatstring, d_skystring, d_coaddimage, d_expmap
string d_masktyp, d_flatfield, d_objmasksuffix, d_tplname, d_refimage, d_prefix
string d_suffix, d_scaling, d_zeroing, d_weighting, d_observatory, d_im_extn
string d_list, f_list, s_list, d_imflatpars, d_imskypars, d_imcoaddpars, d_stats
string d_substring, d_areamask, d_epoch, d_ra, d_dec, d_wordscale, d_wordzero
string d_wordweight, d_imsection, old_string, old_list, d_whentpl, d_patternsub
string subpat_list
real d_maskval, d_extcoeff, d_airzero, temp2_num, d_mingoodexp, d_angle, d_scale
real d_bpfrac
int d_flat_num, d_sky_num, temP_num, d_magfac, d_rotmagfac
int d_nsmooth, d_subsample, d_filtsize, d_ngrow, good_value
bool do_first, sub_dark, quick_look, do_dflat, do_sflat, do_skysub, d_interact
bool obj_mask, do_shift, do_coadd, do_mkobjmask, do_masklet, do_crzap, echo_g
bool do_rotate, do_photcheck, do_photscale, do_trim, do_qkflat, do_qksky, d_ut
bool d_ddmmyy, d_zeroout, d_flatsave, d_skysave, d_tpl, d_forcescale, d_coords
bool d_premask, d_useimages, d_displayim, d_prescale, d_prezero, d_stack, go
bool d_unstack, d_unzero, d_unscale, d_maskedstat, d_sky_del, d_flip, d_addsky
bool d_bpzero, d_invert, d_norot, get_stats, d_iterstat, d_shortcut, d_remake
bool flat_stdpars, sky_stdpars, coadd_stdpars, d_makeavg, d_ptv, d_apply, re_do
bool d_subtract, d_airmass, d_airauto, d_putscale, d_putzero, d_putweight 
bool d_editfiles, d_sky_tpl, d_flat_tpl, after_subpat, during_subpat
bool d_editimshift

struct datelist

# 	COMMAND LINE PARAMETERS
i_list = ilist
root_name = rootname
BP_mask = badpixmask
instru_ment = instrument
# 	WHICH TASKS TO DO? PARAMETERS
do_first = dofirst
re_do = redo
d_dark = imgdark
	sub_dark=no
	if (d_dark != "") sub_dark=yes
do_flat = doflat
	do_dflat = no; do_qkflat = no; do_sflat = no
	if (doflat=="domeflat") do_dflat = yes
	if (doflat=="qkflat") do_qkflat = yes
	if (doflat=="irflat") do_sflat = yes
do_sky = dosky
	do_qksky = no; do_skysub = no
	if (dosky=="qksky") do_qksky = yes
	if (dosky=="irsky") do_skysub = yes
obj_mask = objmask
do_shift = doshift
get_stats = getstats
do_coadd = docoadd
do_mkobjmask = domkobjmask
do_masklet = domasklet
do_trim = dotrim
echo_g = makenoise
# 	GENERAL PARAMETERS
d_darkstring = darkstring
d_flatstring = flatstring
d_skystring = skystring
log_file = logfile
d_imflatpars = imflatpars
d_imskypars = imskypars
d_imcoaddpars = imcoaddpars
d_im_extn = im_extn
# 	DOFIRST+ PARAMETERS
d_coords = coords
d_airmass = airmass
d_airauto = airauto
d_epoch = epoch
d_ra = ra
d_dec = dec
d_observatory = observatory
d_ut = ut
d_ddmmyy = ddmmyy
# 	FLATFIELDING AND SKY-SUBTRACTION PARAMETERS
d_zeroout = zeroout
d_flatfield = flatfield
d_flat_num = flat_num
d_flatsave = flatsave
d_objmasksuffix = objmsuffix
d_remake = remake
d_iterstat = iterstat
d_premask = premask
d_apply = apply
d_sky_num = sky_num
d_skysave = skysave
d_whentpl = whentpl
	d_tpl = no; d_flat_tpl = no; d_sky_tpl = no
        if (d_whentpl=="flat") d_flat_tpl = yes
        if (d_whentpl=="sky") d_sky_tpl = yes
	if (d_flat_tpl || d_sky_tpl) d_tpl=yes
d_tplname = tplname
d_addsky = addsky
d_patternsub = patternsub
	during_subpat = no; after_subpat = no
	if (d_patternsub=="during") during_subpat=yes
	if (d_patternsub=="after") after_subpat=yes
d_forcescale = forcescale
d_shortcut = shortcut
# 	IRSHIFT PARAMETERS (DOSHIFT+)
d_refimage = refimage
d_prefix = prefix
d_suffix = suffix
d_useimages = useimages
d_displayim = displayim
d_ptv = ptv
d_imsection = imsection
d_editfiles = editfiles
#	GETSTATS+ PARAMETERS
d_masktyp = masktyp
d_maskval = maskval
#	IRCOADD PARAMETERS (DOCOADD+)
d_coaddimage = coaddimage
	fileroot (d_coaddimage,validim+); d_coaddimage = fileroot.root
d_expmap = expmap
	fileroot (d_expmap,validim+); d_expmap = fileroot.root
d_scaling = scaling
d_zeroing = zeroing
d_weighting = weighting
d_magfac = magfac
d_prescale = prescale
d_prezero = prezero
d_stack = stack
d_unstack = unstack
d_unzero = unzero
d_unscale = unscale
d_putscale = putscale
d_wordscale = wordscale
d_putzero = putzero
d_wordzero = wordzero
d_putweight = putweight
d_wordweight = wordweight
d_extcoeff = extcoeff
d_airzero = airzero
d_maskedstat = maskedstat
d_statfile = statfile
d_makeavg = makeavg
d_flip = flip
# 	MKOBJMASK/MASKLET PARAMETERS (DOMKOBJMASK+/DOMASKLET+)
d_areamask = areamask
d_subtract = subtract
d_substring = substring
d_nsmooth = nsmooth
d_subsample = subsample
d_filtsize = filtsize
d_ngrow = ngrow
d_interact = interact
d_editimshift = editimshift
# 	TRIM PARAMETERS (DOTRIM+)
d_stats = stats
d_mingoodexp = mingoodexp

# Constructed parameters
d_list = i_list // d_darkstring
# If you don't plan to subtract the dark within dofirst+,
# and the dark-subtracted image list doesn't already exist,
# use the original list to do flatfielding etc. on:
	if (!(sub_dark && do_first) && !access(d_list)) d_list = i_list 
#f_list = d_list // d_flatstring
#s_list = f_list // d_skystring
d_sky_del = yes
flat_stdpars = no
sky_stdpars = no
coadd_stdpars = no

# The "go" parameter won't let the task run if certain tasks aren't loaded.
go=yes
if(do_shift || do_coadd){
	if(!deftask("filecalc")) {go=no}
}
if(do_coadd){
	if(!defpac("imgtools")) {go=no}
}
if(go) {

# Set up log file, appending if it already exists
if (log_file == "") log_file="log_"//i_list
print("", >> log_file)
del ("_gooDaTe", ver-, >& "dev$null")
!date > _gooDaTe
type ("_gooDaTe") | scan (datelist)
del ("_gooDaTe", ver-, >& "dev$null")
print("----------  DOPHIIRS started at "//datelist, >> log_file)

# If darksubbed image list already exists, reset darksubbed image suffix
if (do_first && sub_dark) {
	x_tmpstring = d_darkstring; y_tmpstring = d_darkstring//d_darkstring
	old_string = d_darkstring; old_list = d_list
	if (d_darkstring!="") {
		while (access(d_list)) {
			old_string = d_darkstring; old_list = d_list
			d_list = d_list // x_tmpstring
			d_darkstring = d_darkstring // x_tmpstring
		}
	}
	if (!re_do) {
		d_list = old_list
		d_darkstring = old_string
	}
}

# Set up instrument-dependent parameters and prep images, w/poss. darksub
if (instru_ment == "generic") {
	if (d_imflatpars=="") flat_stdpars=yes
        if (d_imskypars=="") sky_stdpars=yes
        if (d_imcoaddpars=="") coadd_stdpars=yes
	if (do_first) {
	print("----------  Setting up images using first.  -------------")
		first (imagelist=i_list, darksub=sub_dark, badmask=BP_mask, dark=d_dark, darkstring=d_darkstring, coords=d_coords, airmass=d_airmass, airauto=d_airauto, epoch=d_epoch, ra=d_ra, dec=d_dec, observatory=d_observatory, ut=d_ut, ddmmyy=d_ddmmyy, echog=echo_g)
	}	
}	
else if (instru_ment == "irim") {
	d_observatory="kpno"
	if (d_imflatpars=="") d_imflatpars="phiirs$irflatirim.par"
	if (d_imskypars=="") d_imskypars="phiirs$irskyirim.par"
	if (d_imcoaddpars=="") d_imcoaddpars="phiirs$ircoaddirim.par"
	if (do_first) {
	print("----------  Setting up images using irimfirst.  ---------")
		irimfirst (i_list, no, sub_dark, suffix=d_darkstring, dark=d_dark, badmask=BP_mask, echog=echo_g)
	}	
}	
else if (instru_ment == "kir") {
	d_observatory="cfht"
	d_premask=yes
	d_maskedstat=yes
	if (d_imflatpars=="") d_imflatpars="phiirs$irflatkir.par"
	if (d_imskypars=="") d_imskypars="phiirs$irskykir.par"
	if (d_imcoaddpars=="") d_imcoaddpars="phiirs$ircoaddkir.par"
	d_nsmooth = 9
	d_subsample = 7
	d_filtsize = 15
	d_ngrow = 15
	if (do_first) {
	print("----------  Setting up images using cfhtfirst.  ---------")
		cfhtfirst (imagelist=i_list, darksub=sub_dark, badmask=BP_mask, project+, dark=d_dark, darkstring=d_darkstring, observatory=d_observatory, ddmmyy+, echog=echo_g)
	}	
}	
else if (instru_ment == "nsfcam") {
	d_observatory="cfht"
	if (d_imflatpars=="") d_imflatpars="phiirs$irflatirtf.par"
	if (d_imskypars=="") d_imskypars="phiirs$irskyirtf.par"
	if (d_imcoaddpars=="") d_imcoaddpars="phiirs$ircoaddirtf.par"
	if (do_first) {
	print("----------  Setting up images using irtffirst.  ---------")
		irtffirst (i_list, no, sub_dark, suffix=d_darkstring, dark=d_dark, badmask=BP_mask, echog=echo_g)
	}	
}	
else if (instru_ment == "onis") {
	d_observatory="kpno"
	d_premask=yes
	d_maskedstat=yes
	if (d_imflatpars=="") d_imflatpars="phiirs$irflatonis.par"
	if (d_imskypars=="") d_imskypars="phiirs$irskyonis.par"
	if (d_imcoaddpars=="") d_imcoaddpars="phiirs$ircoaddonis.par"
	d_nsmooth = 3
	d_subsample = 3
	d_filtsize = 15
	d_ngrow = 1
	if (do_first) {
	print("----------  Setting up images using onisfirst.  ---------")
		onisfirst (i_list, sub_dark, BP_mask, dark=d_dark, darkstring=d_darkstring, coords=d_coords, airmass=d_airmass, airauto=d_airauto, epoch=d_epoch, ra=d_ra, dec=d_dec, observatory=d_observatory, ut+, ddmmyy+, echog=echo_g)
	}	
}	
else if (instru_ment == "pisces") {
	d_observatory="kpno"
#	d_zeroout=yes
	d_premask=yes
	d_maskedstat=yes
	if (d_imflatpars=="") d_imflatpars="phiirs$irflatpisces.par"
	if (d_imskypars=="") d_imskypars="phiirs$irskypisces.par"
	if (d_imcoaddpars=="") d_imcoaddpars="phiirs$ircoaddpisces.par"
	if (do_first) {
	print("----------  Setting up images using piscesfirst.  -------")
		piscesfirst (i_list, sub_dark, BP_mask, dark=d_dark, darkstring=d_darkstring, coords=d_coords, airmass=d_airmass, airauto=d_airauto, epoch=d_epoch, ra=d_ra, dec=d_dec, observatory=d_observatory, ut+, ddmmyy+, echog=echo_g)
	}	
}	
else if (instru_ment == "so256") {
	if (d_imflatpars=="") d_imflatpars="phiirs$irflat256.par"
	if (d_imskypars=="") d_imskypars="phiirs$irsky256.par"
	if (d_imcoaddpars=="") d_imcoaddpars="phiirs$ircoadd256.par"
	if (do_first) {
	print("----------  Setting up SO 256^2 images using first.  ----")
		first (imagelist=i_list, darksub=sub_dark, badmask=BP_mask, dark=d_dark, darkstring=d_darkstring, coords=d_coords, airmass=d_airmass, airauto=d_airauto, epoch=d_epoch, ra=d_ra, dec=d_dec, observatory=d_observatory, ut=d_ut, ddmmyy=d_ddmmyy, echog=echo_g)
	}	
}
print("", >> log_file)


# If flatfielded image list already exists, reset flatfielded image suffix
#if (do_dflat || do_qkflat || do_sflat) {
	f_list = d_list // d_flatstring
	x_tmpstring = d_flatstring; y_tmpstring = d_flatstring//d_flatstring
	old_string = d_flatstring; old_list = f_list
	if (d_flatstring!="") {
		while (access(f_list)) {
			old_string = d_flatstring; old_list = f_list
			f_list = f_list // x_tmpstring
			d_flatstring = d_flatstring // x_tmpstring
		}
	}
        if (!re_do || (re_do && !do_dflat && !do_qkflat && !do_sflat)) {
		f_list = old_list 
		d_flatstring = old_string
		if (access(f_list)) {
			do_dflat=no; do_qkflat=no; do_sflat=no
		}
	}
#}
# Flatten using domeflat...
if (do_dflat) {
	print("----------  Flat-fielding using domeflat.  --------------")
	print("----------  Flat-fielding using domeflat.", >> log_file)
	domeflat (imagelist=d_list, Flatstring=d_flatstring, darksub=sub_dark, dark=d_dark, flatfield=d_flatfield, zeroout=d_zeroout, badmask=BP_mask, logfile=log_file, tpl=d_flat_tpl, tplname=d_tplname, echog=echo_g)
	print("", >> log_file)

# ...or quick-look flattening...
} else if (do_qkflat) {
	print("----------  Flat-fielding using qkflat.  ----------------")
	print("----------  Flat-fielding using qkflat.", >> log_file)
	if (obj_mask) {
	print("----------  Also using objmasks.  -----------------------")
		hedit ("@"//d_list,"BPM",("(@'OBJMASK')"),add+,ver-,sho-,upd+)
	}
	qkflat (root_name, d_list, d_flatstring, d_flatstring//"."//d_im_extn, log_file, sub_dark, d_dark, BP_mask, d_zeroout, no, mkflat=d_remake, iterstat=d_iterstat, doflat=d_apply, tpl=d_flat_tpl, tplname=d_tplname, imflatpars=d_imflatpars, v210-, echog=echo_g)
	if(obj_mask)hedit("@"//d_list,"BPM",("(@'BPMASK')"),add+,ver-,sho-,upd+)
	if(obj_mask)hedit("@"//f_list,"BPM",("(@'BPMASK')"),add+,ver-,sho-,upd+)
	print("", >> log_file)

# ...or self-flattening.
} else if (do_sflat) {
	print("----------  Flat-fielding using irflat.  ----------------")
	print("----------  Flat-fielding using irflat.", >> log_file)
if (obj_mask) print("----------  Also using objmasks.  -----------------------")
# If number of images to use is INDEF, set to highest possible EVEN number
	if(d_flat_num==INDEF){
		count (i_list) | scan (temP_num)
		temP_num=temP_num-1
		temp2_num=temP_num/2.
		if((temp2_num-int(temp2_num))!=0.)
			temP_num=temP_num-1
		d_flat_num=temP_num
	}
	irflat (d_list, d_flatstring, d_flat_num, obj_mask, log_file, premask=d_premask, forcescale=d_forcescale, stdpars=flat_stdpars, flatsave=d_flatsave, same+, suffix=d_objmasksuffix, tpl=d_flat_tpl, tplname=d_tplname, v210-, echog=echo_g, imflatpars=d_imflatpars)
	print("", >> log_file)
}


# If skysubbed image list already exists, reset skysubbed image suffix
#if (do_skysub || do_qksky) {
	s_list = f_list // d_skystring
	x_tmpstring = d_skystring; y_tmpstring = d_skystring//d_skystring
	old_string = d_skystring; old_list = s_list
	if (d_skystring!="") {
		while (access(s_list)) {
			old_string = d_skystring; old_list = s_list
			s_list = s_list // x_tmpstring
			d_skystring = d_skystring // x_tmpstring
		}
	}
        if (!re_do || (re_do && !do_skysub && !do_qksky)) {
		s_list = old_list 
		d_skystring = old_string
		if (access(s_list)) {
			do_skysub=no; do_qksky=no
		}
	}
#}
# Sky-subtract using running sky...
if (do_skysub) {
	print("----------  Sky-subtracting using irsky.  ---------------")
	print("----------  Sky-subtracting using irsky.", >> log_file)
# If list of sky-subtracted images doesn't exist, use list of flatfielded ones
	if (!access(f_list)) f_list = d_list
# If number of images to use is INDEF, set to highest possible EVEN number
	if(d_sky_num==INDEF){
		count (i_list) | scan (temP_num)
		temP_num=temP_num-1
		temp2_num=temP_num/2.
		if((temp2_num-int(temp2_num))!=0.)
			temP_num=temP_num-1
		d_sky_num=temP_num
	}
	if(d_skysave)d_sky_del=no
	irsky (f_list, d_skystring, d_sky_num, obj_mask, log_file, stdpars=sky_stdpars, sky_del=d_sky_del, same+, suffix=d_objmasksuffix, subpattern=during_subpat, tpl=d_sky_tpl, tplname=d_tplname, addsky=d_addsky, forcescale=d_forcescale, premask=d_premask, csky_del+, myway-, shortcut=d_shortcut, imskypars=d_imskypars, echog=echo_g)
	print("", >> log_file)
	
# ...or quick-look sky-subtraction.
} else if (do_qksky) {
	print("----------  Sky-subtracting using qksky.  ---------------")
	print("----------  Sky-subtracting using qksky.", >> log_file)
# If list of sky-subtracted images doesn't exist, use list of flatfielded ones
	if (!access(f_list)) f_list = d_list
	if (obj_mask) {
	print("----------  Also using objmasks.  -----------------------")
		hedit ("@"//f_list,"BPM",("(@'OBJMASK')"),add+,ver-,sho-,upd+)
	}
	qksky (root_name, f_list, log_file, d_skystring, d_flatstring//d_skystring//"."//d_im_extn, stdpars=sky_stdpars, stdstar-, zeroout=d_zeroout, maskname=BP_mask, subpattern=during_subpat, tpl=d_sky_tpl, tplname=d_tplname, mksky=d_remake, iterstat=d_iterstat, dosky=d_apply, addsky=d_addsky, forcescale=d_forcescale, premask=d_premask, imskypars=d_imskypars, echog=echo_g)
	if(obj_mask && access(f_list))hedit("@"//f_list,"BPM",("(@'BPMASK')"),add+,ver-,sho-,upd+)
	if(obj_mask && access(s_list))hedit("@"//s_list,"BPM",("(@'BPMASK')"),add+,ver-,sho-,upd+)
	print("", >> log_file)
}


# Subtract pattern noise 
if (after_subpat) {
	subpat_list = s_list
	if (!access(s_list)) subpat_list = f_list
	subpattern(subpat_list, "", startline=1, finishline=512, blankname="blank_pattern.fits", ver-, useimgs+, saveimgs+, echog=echo_g)
}


# Get iterative statistics of images to be coadded
if (get_stats) {
	stat_list = s_list
	if (!access(s_list)) stat_list = f_list
	if (access(stat_list//".stats")) {
		if (!re_do) {
			print (stat_list//".stats exists... not recreated.")
		print (stat_list//".stats exists... not recreated.", >>log_file)
		} else {
			#	if (!access(stat_list)) stat_list = d_list
			#	if (!access(stat_list)) stat_list = i_list
			del (stat_list//".stats_old", ver-, >& "dev$null")
			rename (stat_list//".stats", stat_list//".stats_old")
			print ("Recreating "//stat_list//".stats; old version renamed "//stat_list//".stats_old")
			print ("Recreating "//stat_list//".stats; old version renamed "//stat_list//".stats_old", >> log_file)
		}
	}
	if (!access(stat_list//".stats")) {
		if (d_masktyp=="none") {
	print ("masktyp set to none... using iterstat instead of maskstat.")
			d_premask=no
		}
		if (d_premask) {
       print("----------  Outputting maskstat results to "//stat_list//".stats")
			print("----------  Outputting maskstat results to "//stat_list//".stats", >> log_file)
			if (d_masktyp=="goodval") {
				good_value=int(d_maskval)
			} else if (d_masktyp=="badval") {
				good_value=int(1.-d_maskval)
			}
			maskstat ("@"//stat_list, "!BPM", goodvalue=good_value, iterstat+, addh+, printit+, >> stat_list//".stats")
		} else {
       print("----------  Outputting iterstat results to "//stat_list//".stats")
			print("----------  Outputting iterstat results to "//stat_list//".stats", >> log_file)
			iterstat ("@"//stat_list, print+, addh+, >> stat_list//".stats")
		}
	}
	type (stat_list//".stats")
}


# Measure image shifts
if (do_shift) {
	print("----------  Calculating image shifts using irshift.  ----")
	print("----------  Calculating image shifts using irshift.", >> log_file)
# If list of sky-subtracted images doesn't exist, use list of flatfielded ones
	if (!access(s_list)) s_list = f_list
# If refimage, prefix or suffix are not set, use defaults
	if (d_refimage=="")
		fields (s_list, 1, lines="1-1") | scan (d_refimage)
	if (d_prefix=="") d_prefix=root_name
	if (d_suffix=="") {
		x_tmpstring = "sh1"
		y_tmpstring=d_prefix//".roundoff."//x_tmpstring
		old_string = x_tmpstring; old_list = y_tmpstring
		while (access(y_tmpstring)) {
			old_string = x_tmpstring; old_list = y_tmpstring
			x_tmpstring = x_tmpstring + 1
			y_tmpstring=d_prefix//".roundoff."//x_tmpstring
		}
        	if (!re_do) {
			y_tmpstring = old_list 
			x_tmpstring = old_string
		}
		d_suffix=x_tmpstring
	}
	if(re_do || (!re_do && !access(y_tmpstring))) {
		irshift (s_list, d_refimage, d_prefix, d_suffix, fracshift-, useimages=d_useimages, displayim=d_displayim, ptv=d_ptv, imsection=d_imsection, editfiles=d_editfiles, combdata-, echog=echo_g)
	}
	print("", >> log_file)
}


# Coadd images
if (do_coadd) {
	print("----------  Coadding images using ircoadd.  -------------")
	print("----------  Coadding images using ircoadd.", >> log_file)
# If shift-file prefix or suffix not set, use highest-numbered image shifts file
	if (d_prefix=="") d_prefix=root_name
        if (d_suffix=="") {
		x_tmpstring = "sh1"
                x_oldstring = x_tmpstring
               	y_tmpstring=d_prefix//".roundoff."//x_tmpstring
		while (access(y_tmpstring)) {
                        x_oldstring = x_tmpstring
                        x_tmpstring = x_tmpstring + 1
                        y_tmpstring=d_prefix//".roundoff."//x_tmpstring
                }
                x_tmpstring = x_oldstring
                d_suffix=x_tmpstring
	}
# If list of sky-subtracted images doesn't exist, use list of flatfielded ones
	if (!access(s_list)) s_list = f_list
# If name of statfile not set, use the same default as the ircoadd task
	if (d_statfile=="") d_statfile=s_list//".stats"
# If name of coadded image not set, use the first available "_coaddN" suffix
	if (d_coaddimage=="") {
		y_tmpstring = ""
		x_tmpstring = "_coadd1"
		y_tmpstring=root_name//x_tmpstring//"."//d_im_extn
		while (access(y_tmpstring)) {
			x_tmpstring = x_tmpstring + 1
			y_tmpstring=root_name//x_tmpstring//"."//d_im_extn
		}
		d_coaddimage=root_name//x_tmpstring//"."//d_im_extn
	}
	if(re_do || (!re_do && !access(y_tmpstring))) {
		 ircoadd (s_list, d_coaddimage, d_expmap, d_prefix//".roundoff."//d_suffix, d_scaling, d_zeroing, d_weighting, d_magfac, d_stack, log_file, prescale=d_prescale, unscale=d_unscale, putscale=d_putscale, wordscale=d_wordscale, extcoeff=d_extcoeff, airzero=d_airzero, prezero=d_prezero, unzero=d_unzero, putzero=d_putzero, wordzero=d_wordzero, putweight=d_putweight, wordweight=d_wordweight, unstack=d_unstack, maskedstat=d_maskedstat, statfile=d_statfile, stdpars=coadd_stdpars, makeavg=d_makeavg, flip=d_flip, tpl=d_tpl, echog=echo_g, imcoaddpars=d_imcoaddpars)
	} else {
		print(d_coaddimage//" already exists ... not recreating.")
	  print(d_coaddimage//" already exists ... not recreating.", >>log_file)
	}
	print("", >> log_file)
}


# Make object mask for coadded image
if (do_mkobjmask) {
	print("----------  Making object mask using mkobjmask.  ---------")
	print("----------  Making object mask using mkobjmask.", >> log_file)
# If name of coadded image not set, use highest-numbered "_coaddN" suffix
	if (d_coaddimage=="") {
		x_tmpstring = "_coadd1"
                x_oldstring = x_tmpstring
		y_tmpstring=root_name//x_tmpstring//"."//d_im_extn
		while (access(y_tmpstring)) {
                        x_oldstring = x_tmpstring
			x_tmpstring = x_tmpstring + 1
			y_tmpstring=root_name//x_tmpstring//"."//d_im_extn
		}
                x_tmpstring = x_oldstring
		d_coaddimage=root_name//x_tmpstring//"."//d_im_extn
	}
	mkobjmask (d_coaddimage, d_expmap, suffix="objmask", prefix="norm", areamask=d_areamask, subtract=d_subtract, substring=d_substring, nsmooth=d_nsmooth, subsample=d_subsample, filtsize=d_filtsize, ngrow=d_ngrow, interact=d_interact, echog=echo_g)
	print("", >> log_file)
}


# Make object masks for individual images
if (do_masklet) {
	print("----------  Making individual object masks with masklet.  ")
	print("----------  Making individual object masks with masklet.", >> log_file)
# If name of coadded image not set, use highest-numbered "_coaddN" suffix
	if (d_coaddimage=="") {
		x_tmpstring = "_coadd1"
                x_oldstring = x_tmpstring
		y_tmpstring=root_name//x_tmpstring//"."//d_im_extn
		while (access(y_tmpstring)) {
                        x_oldstring = x_tmpstring
			x_tmpstring = x_tmpstring + 1
			y_tmpstring=root_name//x_tmpstring//"."//d_im_extn
		}
                x_tmpstring = x_oldstring
		d_coaddimage=root_name//x_tmpstring//"."//d_im_extn
	}
	masklet (d_coaddimage, "", d_objmasksuffix, shiftfile="", editfile=d_editimshift, flip=d_flip, update+, echog=echo_g)
	print("", >> log_file)
}


# Created constant-rms image with a minimum exposure time
if (do_trim) {
	print("----------  Creating constant-rms image.  ----------------")
	print("----------  Creating constant-rms image.", >> log_file)
# If name of coadded image not set, use highest-numbered "_coaddN" suffix
	if (d_coaddimage=="") {
		x_tmpstring = "_coadd1"
                x_oldstring = x_tmpstring
		y_tmpstring=root_name//x_tmpstring//"."//d_im_extn
		while (access(y_tmpstring)) {
                        x_oldstring = x_tmpstring
			x_tmpstring = x_tmpstring + 1
			y_tmpstring=root_name//x_tmpstring//"."//d_im_extn
		}
                x_tmpstring = x_oldstring
		d_coaddimage=root_name//x_tmpstring//"."//d_im_extn
	}
# If name of trimmed-image stat file not set, use "*_coaddN.trimstats"
	if (d_stats=="") {
		fileroot (d_coaddimage, validim+)
		d_stats=fileroot.root//".trimstats"
	}
	trim (d_coaddimage, d_expmap, d_stats, out="trim", subtract=d_subtract, mingoodexp=d_mingoodexp, echog=echo_g) 
	print("", >> log_file)
}


del ("_gooDaTe", ver-, >& "dev$null")
!date > _gooDaTe
type ("_gooDaTe") | scan (datelist)
del ("_gooDaTe", ver-, >& "dev$null")
print("----------  DOPHIIRS complete at "//datelist, >> log_file)
print("", >> log_file); print("")
print("DOPHIIRS complete at "//datelist//"; detailed log in "//log_file)


} else {
	print("WARNING: either ctio.filecalc task is not loaded (if doshift+ or docoadd+)")
	print("or stsdas.toolbox.imgtools package isn't loaded (if docoadd+).")
	print("Please load them and restart this task.")
}

if (echo_g) beep

end

