#UT 950709 version
#
#-1 load stsdas.toolbox.imgtools, ctio, & phiirs before running
#0 make lists
#1 irimfirst on all
#2 compare start & end refs & darks
#3 imcombine all images
#4 iterstat interspersed refs
#5 iterstat observations
#6 convert short-exposure images to actual flux and exposure time
#7 convert long-exposure images to actual flux and exposure time
#8 find average lamp values
#9 correct images for lamp variability
#10 turn (exptime,flux) file into (flux,%) file and graph

#0 make lists... ideally want to replace by directing specific files to
#	specific lists.
files nldark_start*imh >> list.nl1_dark_start
files nldark_end*imh >> list.nl1_dark_end
copy list.nl1 list.nl1_refs
copy list.nl1 list.nl1_ref_start
copy list.nl1 list.nl1_ref_end
copy list.nl1 list.nl1_005s
copy list.nl1 list.nl1_0075s
copy list.nl1 list.nl1_01s
copy list.nl1 list.nl1_02s
copy list.nl1 list.nl1_04s
copy list.nl1 list.nl1_06s
copy list.nl1 list.nl1_10s
copy list.nl1 list.nl1_14s
copy list.nl1 list.nl1_18s
copy list.nl1 list.nl1_22s
copy list.nl1 list.nl1_26s
copy list.nl1 list.nl1_30s
copy list.nl1 list.nl1_34s
copy list.nl1 list.nl1_38s
copy list.nl1 list.nl1_42s
copy list.nl1 list.nl1_46s
copy list.nl1 list.nl1_50s
vi list.nl1_*
count list.nl1_* >> list.nl1_counts
vi list.nl1_counts

#1 irimfirst on all
irimfirst list.nl1 no no badmask=bpk.pl
irimfirst list.nl1_dark_start no no badmask=bpk.pl
irimfirst list.nl1_dark_end no no badmask=bpk.pl

#2 imcombine start & end refs & darks
imcombine @list.nl1_ref_start nl1_ref_start comb=average rej=ccdclip lsig=3. hsig=3. gain=10.46 rdnoise=35. masktyp=none expname=exptime logfile=log.nl1 weight=none scale=none zero=none statsec="" project=no plfile="" sigma="" offsets=none snoise=0 grow=0

imcombine @list.nl1_ref_end nl1_ref_end comb=average rej=ccdclip lsig=3. hsig=3. gain=10.46 rdnoise=35. masktyp=none expname=exptime logfile=log.nl1 weight=none scale=none zero=none statsec="" project=no plfile="" sigma="" offsets=none snoise=0 grow=0

imcombine @list.nl1_dark_start nl1_dark_start comb=average rej=ccdclip lsig=3. hsig=3. gain=10.46 rdnoise=35. masktyp=none expname=exptime logfile=log.nl1 weight=none scale=none zero=none statsec="" project=no plfile="" sigma="" offsets=none snoise=0 grow=0

imcombine @list.nl1_dark_end nl1_dark_end comb=average rej=ccdclip lsig=3. hsig=3. gain=10.46 rdnoise=35. masktyp=none expname=exptime logfile=log.nl1 weight=none scale=none zero=none statsec="" project=no plfile="" sigma="" offsets=none snoise=0 grow=0

print("#start & end dark stats", >> "log.nl1")
iterstat nl1_dark_start.imh,nl1_dark_end.imh >> log.nl1

#3 imcombine all images
imcombine @list.nl1_005s nl1_005s comb=average rej=ccdclip lsig=3. hsig=3. gain=10.46 rdnoise=35. masktyp=badval expname=exptime logfile=log.nl1 weight=none scale=none zero=none statsec="" project=no plfile="" sigma="" offsets=none snoise=0 grow=0

imcombine @list.nl1_0075s nl1_0075s comb=average rej=ccdclip lsig=3. hsig=3. gain=10.46 rdnoise=35. masktyp=badval expname=exptime logfile=log.nl1 weight=none scale=none zero=none statsec="" project=no plfile="" sigma="" offsets=none snoise=0 grow=0

imcombine @list.nl1_01s nl1_01s comb=average rej=ccdclip lsig=3. hsig=3. gain=10.46 rdnoise=35. masktyp=badval expname=exptime logfile=log.nl1 weight=none scale=none zero=none statsec="" project=no plfile="" sigma="" offsets=none snoise=0 grow=0

imcombine @list.nl1_02s nl1_02s comb=average rej=ccdclip lsig=3. hsig=3. gain=10.46 rdnoise=35. masktyp=badval expname=exptime logfile=log.nl1 weight=none scale=none zero=none statsec="" project=no plfile="" sigma="" offsets=none snoise=0 grow=0

imcombine @list.nl1_04s nl1_04s comb=average rej=ccdclip lsig=3. hsig=3. gain=10.46 rdnoise=35. masktyp=badval expname=exptime logfile=log.nl1 weight=none scale=none zero=none statsec="" project=no plfile="" sigma="" offsets=none snoise=0 grow=0

imcombine @list.nl1_06s nl1_06s comb=average rej=ccdclip lsig=3. hsig=3. gain=10.46 rdnoise=35. masktyp=badval expname=exptime logfile=log.nl1 weight=none scale=none zero=none statsec="" project=no plfile="" sigma="" offsets=none snoise=0 grow=0

imcombine @list.nl1_10s nl1_10s comb=average rej=ccdclip lsig=3. hsig=3. gain=10.46 rdnoise=35. masktyp=badval expname=exptime logfile=log.nl1 weight=none scale=none zero=none statsec="" project=no plfile="" sigma="" offsets=none snoise=0 grow=0

imcombine @list.nl1_14s nl1_14s comb=average rej=ccdclip lsig=3. hsig=3. gain=10.46 rdnoise=35. masktyp=badval expname=exptime logfile=log.nl1 weight=none scale=none zero=none statsec="" project=no plfile="" sigma="" offsets=none snoise=0 grow=0

imcombine @list.nl1_18s nl1_18s comb=average rej=ccdclip lsig=3. hsig=3. gain=10.46 rdnoise=35. masktyp=badval expname=exptime logfile=log.nl1 weight=none scale=none zero=none statsec="" project=no plfile="" sigma="" offsets=none snoise=0 grow=0

imcombine @list.nl1_22s nl1_22s comb=average rej=ccdclip lsig=3. hsig=3. gain=10.46 rdnoise=35. masktyp=badval expname=exptime logfile=log.nl1 weight=none scale=none zero=none statsec="" project=no plfile="" sigma="" offsets=none snoise=0 grow=0

imcombine @list.nl1_26s nl1_26s comb=average rej=ccdclip lsig=3. hsig=3. gain=10.46 rdnoise=35. masktyp=badval expname=exptime logfile=log.nl1 weight=none scale=none zero=none statsec="" project=no plfile="" sigma="" offsets=none snoise=0 grow=0

imcombine @list.nl1_30s nl1_30s comb=average rej=ccdclip lsig=3. hsig=3. gain=10.46 rdnoise=35. masktyp=badval expname=exptime logfile=log.nl1 weight=none scale=none zero=none statsec="" project=no plfile="" sigma="" offsets=none snoise=0 grow=0

imcombine @list.nl1_34s nl1_34s comb=average rej=ccdclip lsig=3. hsig=3. gain=10.46 rdnoise=35. masktyp=badval expname=exptime logfile=log.nl1 weight=none scale=none zero=none statsec="" project=no plfile="" sigma="" offsets=none snoise=0 grow=0

imcombine @list.nl1_38s nl1_38s comb=average rej=ccdclip lsig=3. hsig=3. gain=10.46 rdnoise=35. masktyp=badval expname=exptime logfile=log.nl1 weight=none scale=none zero=none statsec="" project=no plfile="" sigma="" offsets=none snoise=0 grow=0

imcombine @list.nl1_42s nl1_42s comb=average rej=ccdclip lsig=3. hsig=3. gain=10.46 rdnoise=35. masktyp=badval expname=exptime logfile=log.nl1 weight=none scale=none zero=none statsec="" project=no plfile="" sigma="" offsets=none snoise=0 grow=0

imcombine @list.nl1_46s nl1_46s comb=average rej=ccdclip lsig=3. hsig=3. gain=10.46 rdnoise=35. masktyp=badval expname=exptime logfile=log.nl1 weight=none scale=none zero=none statsec="" project=no plfile="" sigma="" offsets=none snoise=0 grow=0

imcombine @list.nl1_50s nl1_50s comb=average rej=ccdclip lsig=3. hsig=3. gain=10.46 rdnoise=35. masktyp=badval expname=exptime logfile=log.nl1 weight=none scale=none zero=none statsec="" project=no plfile="" sigma="" offsets=none snoise=0 grow=0

#4 iterstat interspersed refs
print("#interspersed ref stats", >> "log.nl1")
iterstat nl1_ref_start.imh,@list.nl1_refs,nl1_ref_end.imh >> stats.nl1_refs_1
type stats.nl1_refs_1 >> log.nl1

#5 iterstat observations
del _tmpdagnabit ver- >& dev$null
iterstat nl1*s.imh[25:225,25:225] >> stats.nl1_1
hsel nl1*s.imh int_s yes >> imhe.nl1_1
fields stats.nl1_1 2 >> _tmpdagnabit
join imhe.nl1_1,_tmpdagnabit out=stats.nl1_2
del _tmpdagnabit ver-

#6 convert short-exposure images to actual flux and exposure time
print(" ", >> "stats.nl1_2")
print("#the first time this is edited, comment out lines of images with ", >> "stats.nl1_2")
print("#int_time >1.381 seconds.", >> "stats.nl1_2")
vi stats.nl1_2
filecalc stats.nl1_2 "$1+$1-0.381;($1+$1-0.381)*($2/$1)" >> stats.nl1_3
#old (wrong)
#filecalc stats.nl1_2 "$1+$1;($1+$1)*($2/$1)" >> stats.nl1_3

#7 convert long-exposure images to actual flux and exposure time
print(" ", >> "stats.nl1_2")
print("#the second time this is edited, comment out lines of images with ", >> "stats.nl1_2")
print("#int_time <=1.381 seconds.", >> "stats.nl1_2")
vi stats.nl1_2
filecalc stats.nl1_2 "$1+1.0;($1+1.0)*($2/$1)" >> stats.nl1_3

#8 find average lamp values
print(" ", >> "stats.nl1_refs_1")
count stats.nl1_3 | scan(z)
print("#when this is edited, average each two adjacent values together", >> "stats.nl1_refs_1")
print("#so that you end up with "//z//" values total, matching the number ", >> "stats.nl1_refs_1")
print("#of sets of nonlinearity exposures, which will be scaled by these averages.", >> "stats.nl1_refs_1")
print("#Put the average values in file 'stats.nl1_refs_2'.", >> "stats.nl1_refs_1")
print("#This can be done with the IRAF commands:", >> "stats.nl1_refs_1")
print("#	x=0.5* (AVG1 + AVG2); print(x, >> \"stats.nl1_refs_2\"", >> "stats.nl1_refs_1")

vi stats.nl1_refs_1
print("#Are there "//z//" lines of data in this file?  if so, continue...", >> "stats.nl1_refs_2")
vi stats.nl1_refs_2
sort stats.nl1_refs_2 col=1 num+ rev+ | head nlines=1 | scan(z)

print("Do the following IRAF commands after this task stops: ")
print("filecalc stats.nl1_refs_2 \"$1/"//z//"\" >> stats.nl1_refs_3")

#9 correct images for lamp variability
print("filecalc stats.nl1_3,stats.nl1_refs_3 \"$1;$2/($1@2)\" >> stats.nl1_4")

#10 turn (exptime,flux) file into (flux,%) file and graph
print("fields stats.nl1_4 1 | head nlines=1 | scan(x)")
print("fields stats.nl1_4 2 | head nlines=1 | scan(y)")
print("=x")
print("=y")
print("-----insert x and y from above into the line below-----")
print("filecalc stats.nl1_4 \"$2;$2/(y*$1/x)\" >> stats.nl1_5")
print("graph stats.nl1_5 point-")
print("graph stats.nl1_5 point+ append+ overplot+")
print(" ")
print("The file stats.nl1_5 contains the final data points.  `vi stats.nl1_5'")
print("and insert a zero at the end of each column, then run:")
print("         stsdas.statistics.emmethod stats.nl1_5[3,2,1]")
print("to get the slope coefficient from the least-squares solution.")

beep

