# untrim.cl -- script to produce true output magnitudes for objects detected
#		on a variable-exposure-time mosaic.
#
# 	Following two lines produce a list of the objects' INTEGER x,y
#	coordinates and their total COUNTS from FOCAS catalogs.
#
#filter H < image.cat > imagetmp.cat
#catlist x y Li < imagetmp.cat >> untrim.image
#catlist x y Ltotal < imagetmp.cat >> untrim.image
#
# 	Insert 1sig/arsec rms cts or 3sig limit cts in next line
#
imdel untrim.image*.imh ver-
imar imagemask * 999 untrim.imagetmp.imh
#
list="untrim.image"
while (fscan (list, i, j, z) !=EOF) {
  imdel ("tmp.imh", ver-, >& "dev$null")
imar("imagemask["//i//":"//i//","//j//":"//j//"]", "*", z, "tmp.imh")
  imcopy ("tmp.imh", "untrim.imagetmp.imh["//i//":"//i//","//j//":"//j//"]")
  imdel ("tmp.imh", ver-, >& "dev$null")
}
minmax imagenorm force+
imar("imagenorm", "/", minmax.maxval, "imagenormtmp", ver+, noact-)
#
# 	Following two lines are optional.
#
#imar imagenormtmp + 0.03 imagenormtmp
#imreplace imagenormtmp 1. lower=1. upper=INDEF
#
#	Insert zeropoint for image in next line
#
imcalc untrim.imagetmp.imh,imagenormtmp untrim.image.imh "999-2.5*log10(im1 / (sqrt(im2)))"
imdel imagenormtmp ver-
imdel untrim.imagetmp.imh ver-
#
list="untrim.image"
while (fscan (list, i, j, z) !=EOF) {
  imstat("untrim.image.imh["//i//":"//i//","//j//":"//j//"]", fields="mean", format-, >> "untrim.image.truemags")
}
beep
