# xlist.cl -- tool for generating sublists of files extracted from a main list.

# If input list (inlist) has files 1 through N, xlist generates a new output 
# list (outlist) with files 'start' to 'finish', excluding file 'xfile'.    
# 
# originally created 7/22/93 Mark Dickinson

procedure xlist(inlist,outlist,start,finish,xfile)

string	inlist	{prompt="Input list of file names in sequence"}
string 	outlist	{prompt="Output file list"}
int	start	{min=1,prompt="Number of first file to use in list"}
int	finish	{min=1,prompt="Number of last file to use in list"}
int	xfile	{min=1,prompt="Number of file to be excluded from list"}
string	prefix	{"",prompt="Prefix to append to filenames in output list"}
string	*inlst

begin

	string 	fname,outlst
	int	ilist,istart,ifinish,ixfile

# Get query parameters

	inlst	= inlist
	outlst	= outlist
	istart	= start
	ifinish	= finish
	ixfile	= xfile

# Now construct the list

	ilist=1

	while (fscan(inlst,fname) != EOF) {
		if (ilist > ifinish) bye
		if (ilist > (istart-1)) {
			if (ilist != ixfile) {
				files(prefix//fname, >> outlst)
			}
		}
		ilist+=1
	}

	inlst = ""
			    
end
